perf: update documentation of GIT_PERF_REPEAT_COUNT
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
c2116a17
JH
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
3c8f12c9
JH
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
29fi
30if test -z "$TEST_OUTPUT_DIRECTORY"
31then
32 # Similarly, override this to store the test-results subdir
33 # elsewhere
34 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
35fi
36GIT_BUILD_DIR="$TEST_DIRECTORY"/..
37
2006f0ad
RR
38################################################################
39# It appears that people try to run tests without building...
40"$GIT_BUILD_DIR/git" >/dev/null
41if test $? != 1
42then
43 echo >&2 'error: you do not seem to have built git yet.'
44 exit 1
45fi
46
3c8f12c9
JH
47. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48export PERL_PATH SHELL_PATH
49
4cde519f
RR
50# if --tee was passed, write the output not only to the terminal, but
51# additionally to the file test-results/$BASENAME.out, too.
52case "$GIT_TEST_TEE_STARTED, $* " in
53done,*)
54 # do not redirect again
55 ;;
56*' --tee '*|*' --va'*)
57 mkdir -p test-results
58 BASE=test-results/$(basename "$0" .sh)
59 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
60 echo $? > $BASE.exit) | tee $BASE.out
61 test "$(cat $BASE.exit)" = 0
62 exit
63 ;;
64esac
65
e1970ce4
JH
66# For repeatability, reset the environment to known value.
67LANG=C
899460f3 68LC_ALL=C
d9bdd39e 69PAGER=cat
e1970ce4 70TZ=UTC
c2116a17
JH
71TERM=dumb
72export LANG LC_ALL PAGER TERM TZ
8ff99e74 73EDITOR=:
661bfd13
SL
74# A call to "unset" with no arguments causes at least Solaris 10
75# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
76# deriving from the command substitution clustered with the other
77# ones.
3c8f12c9 78unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 79 my @env = keys %ENV;
730477f1
JL
80 my $ok = join("|", qw(
81 TRACE
82 DEBUG
83 USE_LOOKUP
84 TEST
85 .*_TEST
86 PROVE
87 VALGRIND
ac001282 88 UNZIP
edb54081 89 PERF_
730477f1
JL
90 ));
91 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
92 print join("\n", @vars);
93')
5adf84eb 94unset XDG_CONFIG_HOME
29e55cd5
JH
95GIT_AUTHOR_EMAIL=author@example.com
96GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
97GIT_COMMITTER_EMAIL=committer@example.com
98GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 99GIT_MERGE_VERBOSITY=5
f8246281
JH
100GIT_MERGE_AUTOEDIT=no
101export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
102export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
103export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 104export EDITOR
e1970ce4 105
a731fa91
EP
106# Add libc MALLOC and MALLOC_PERTURB test
107# only if we are not executing the test with valgrind
1b3185fc 108if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 109 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
110then
111 setup_malloc_check () {
112 : nothing
113 }
114 teardown_malloc_check () {
115 : nothing
116 }
117else
118 setup_malloc_check () {
119 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
120 export MALLOC_CHECK_ MALLOC_PERTURB_
121 }
122 teardown_malloc_check () {
123 unset MALLOC_CHECK_ MALLOC_PERTURB_
124 }
125fi
a731fa91 126
886a3907
JH
127# Protect ourselves from common misconfiguration to export
128# CDPATH into the environment
129unset CDPATH
130
5565f47c 131unset GREP_OPTIONS
ac001282 132unset UNZIP
5565f47c 133
3d5c0cc9 134case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756
RJ
1351|2|true)
136 echo "* warning: Some tests will not work if GIT_TRACE" \
137 "is set as to trace on STDERR ! *"
138 echo "* warning: Please set GIT_TRACE to something" \
139 "other than 1, 2 or true ! *"
140 ;;
6ce4e61f
CC
141esac
142
cd3c095c
JH
143# Convenience
144#
145# A regexp to match 5 and 40 hexdigits
146_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
147_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
148
3749fde5
JH
149# Zero SHA-1
150_z40=0000000000000000000000000000000000000000
151
3f4ab627
JH
152# Line feed
153LF='
154'
155
342e9ef2
TR
156export _x05 _x40 _z40 LF
157
e1970ce4
JH
158# Each test should start with something like this, after copyright notices:
159#
160# test_description='Description of this test...
161# This test checks if command xyzzy does the right thing...
162# '
163# . ./test-lib.sh
c2116a17
JH
164[ "x$ORIGINAL_TERM" != "xdumb" ] && (
165 TERM=$ORIGINAL_TERM &&
166 export TERM &&
167 [ -t 1 ] &&
168 tput bold >/dev/null 2>&1 &&
169 tput setaf 1 >/dev/null 2>&1 &&
170 tput sgr0 >/dev/null 2>&1
171 ) &&
55db1df0 172 color=t
e1970ce4 173
e1970ce4
JH
174while test "$#" -ne 0
175do
176 case "$1" in
177 -d|--d|--de|--deb|--debu|--debug)
178 debug=t; shift ;;
886856ab
JH
179 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
180 immediate=t; shift ;;
5e2c08c6 181 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 182 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 183 -h|--h|--he|--hel|--help)
570f3226 184 help=t; shift ;;
e1970ce4
JH
185 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
186 verbose=t; shift ;;
1ece1274 187 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
188 # Ignore --quiet under a TAP::Harness. Saying how many tests
189 # passed without the ok/not ok details is always an error.
190 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
191 --with-dashes)
192 with_dashes=t; shift ;;
55db1df0 193 --no-color)
faa4bc35 194 color=; shift ;;
4e1be63c 195 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
3da93652 196 valgrind=t; verbose=t; shift ;;
44138559
JS
197 --tee)
198 shift ;; # was handled already
f423ef5f
JK
199 --root=*)
200 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
201 shift ;;
e1970ce4 202 *)
1f729dca 203 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
204 esac
205done
206
1c0cc756
RJ
207if test -n "$color"
208then
55db1df0 209 say_color () {
c2116a17
JH
210 (
211 TERM=$ORIGINAL_TERM
212 export TERM
55db1df0 213 case "$1" in
1c0cc756
RJ
214 error)
215 tput bold; tput setaf 1;; # bold red
216 skip)
217 tput bold; tput setaf 2;; # bold green
218 pass)
219 tput setaf 2;; # green
220 info)
221 tput setaf 3;; # brown
222 *)
223 test -n "$quiet" && return;;
55db1df0
PH
224 esac
225 shift
5099b99d 226 printf "%s" "$*"
55db1df0 227 tput sgr0
b8eecafd 228 echo
c2116a17 229 )
55db1df0
PH
230 }
231else
232 say_color() {
1ece1274 233 test -z "$1" && test -n "$quiet" && return
55db1df0 234 shift
7bc0911d 235 printf "%s\n" "$*"
55db1df0
PH
236 }
237fi
238
239error () {
240 say_color error "error: $*"
6e7b5aaf 241 GIT_EXIT_OK=t
55db1df0
PH
242 exit 1
243}
244
245say () {
246 say_color info "$*"
247}
248
570f3226
MB
249test "${test_description}" != "" ||
250error "Test script did not set test_description."
251
252if test "$help" = "t"
253then
254 echo "$test_description"
255 exit 0
256fi
257
4d9d62fa 258exec 5>&1
781f76b1 259exec 6<&0
e1970ce4
JH
260if test "$verbose" = "t"
261then
262 exec 4>&2 3>&1
263else
264 exec 4>/dev/null 3>/dev/null
265fi
266
267test_failure=0
268test_count=0
41ac414e
JH
269test_fixed=0
270test_broken=0
2d84e9fb 271test_success=0
e1970ce4 272
d998bd4a
ÆAB
273test_external_has_tap=0
274
faa4bc35 275die () {
6e7b5aaf
CB
276 code=$?
277 if test -n "$GIT_EXIT_OK"
278 then
279 exit $code
280 else
281 echo >&5 "FATAL: Unexpected exit with code $code"
282 exit 1
283 fi
faa4bc35
CB
284}
285
6e7b5aaf 286GIT_EXIT_OK=
35641310 287trap 'die' EXIT
41184273 288
12a29b1a
TR
289# The user-facing functions are loaded from a separate file so that
290# test_perf subshells can have them too
3c8f12c9 291. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 292
886856ab
JH
293# You are not expected to call test_ok_ and test_failure_ directly, use
294# the text_expect_* functions instead.
295
296test_ok_ () {
d5d9de1b 297 test_success=$(($test_success + 1))
5099b99d 298 say_color "" "ok $test_count - $@"
e1970ce4
JH
299}
300
886856ab 301test_failure_ () {
d5d9de1b 302 test_failure=$(($test_failure + 1))
5099b99d 303 say_color error "not ok - $test_count $1"
bf0dd8a8 304 shift
5099b99d 305 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 306 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
307}
308
41ac414e 309test_known_broken_ok_ () {
41ac414e 310 test_fixed=$(($test_fixed+1))
5099b99d 311 say_color "" "ok $test_count - $@ # TODO known breakage"
41ac414e
JH
312}
313
314test_known_broken_failure_ () {
41ac414e 315 test_broken=$(($test_broken+1))
5099b99d 316 say_color skip "not ok $test_count - $@ # TODO known breakage"
41ac414e 317}
886856ab
JH
318
319test_debug () {
8e832ebc 320 test "$debug" = "" || eval "$1"
e1970ce4
JH
321}
322
a7c58f28
JN
323test_eval_ () {
324 # This is a separate function because some tests use
325 # "return" to end a test_expect_success block early.
781f76b1 326 eval </dev/null >&3 2>&4 "$*"
a7c58f28
JN
327}
328
4d9d62fa 329test_run_ () {
b6b0afdc 330 test_cleanup=:
b586744a 331 expecting_failure=$2
a7c58f28 332 test_eval_ "$1"
b6b0afdc 333 eval_ret=$?
b586744a
JH
334
335 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
336 then
1b3185fc 337 setup_malloc_check
a7c58f28 338 test_eval_ "$test_cleanup"
1b3185fc 339 teardown_malloc_check
b586744a 340 fi
1c0cc756
RJ
341 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
342 then
57e1538a
ÆAB
343 echo ""
344 fi
aa0bcf96 345 return "$eval_ret"
4d9d62fa
PR
346}
347
04ece593 348test_skip () {
8586f98b 349 test_count=$(($test_count+1))
04ece593
JH
350 to_skip=
351 for skp in $GIT_SKIP_TESTS
352 do
8586f98b 353 case $this_test.$test_count in
04ece593
JH
354 $skp)
355 to_skip=t
47e67d47 356 break
04ece593
JH
357 esac
358 done
05236a5e
JN
359 if test -z "$to_skip" && test -n "$test_prereq" &&
360 ! test_have_prereq "$test_prereq"
a7bb3940
JS
361 then
362 to_skip=t
363 fi
04ece593
JH
364 case "$to_skip" in
365 t)
07431fc8 366 of_prereq=
05236a5e 367 if test "$missing_prereq" != "$test_prereq"
07431fc8 368 then
05236a5e 369 of_prereq=" of $test_prereq"
07431fc8
JN
370 fi
371
55db1df0 372 say_color skip >&3 "skipping test: $@"
07431fc8 373 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
04ece593
JH
374 : true
375 ;;
376 *)
377 false
378 ;;
379 esac
380}
381
342e9ef2
TR
382# stub; perf-lib overrides it
383test_at_end_hook_ () {
384 :
385}
386
e1970ce4 387test_done () {
6e7b5aaf 388 GIT_EXIT_OK=t
2d84e9fb 389
1c0cc756
RJ
390 if test -z "$HARNESS_ACTIVE"
391 then
342e9ef2 392 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 393 mkdir -p "$test_results_dir"
dd78478f
FC
394 base=${0##*/}
395 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
8ef1abe5 396
c54e6be7
ML
397 cat >>"$test_results_path" <<-EOF
398 total $test_count
399 success $test_success
400 fixed $test_fixed
401 broken $test_broken
402 failed $test_failure
403
404 EOF
8ef1abe5 405 fi
41ac414e
JH
406
407 if test "$test_fixed" != 0
408 then
5099b99d 409 say_color pass "# fixed $test_fixed known breakage(s)"
41ac414e
JH
410 fi
411 if test "$test_broken" != 0
412 then
5099b99d 413 say_color error "# still have $test_broken known breakage(s)"
11d54b8b
JH
414 msg="remaining $(($test_count-$test_broken)) test(s)"
415 else
416 msg="$test_count test(s)"
41ac414e 417 fi
e1970ce4 418 case "$test_failure" in
10b94e28 419 0)
5099b99d 420 # Maybe print SKIP message
bf4b7219
RJ
421 if test -n "$skip_all" && test $test_count -gt 0
422 then
423 error "Can't use skip_all after running some tests"
424 fi
5099b99d
ÆAB
425 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
426
1c0cc756
RJ
427 if test $test_external_has_tap -eq 0
428 then
d87bd7c1
RJ
429 if test $test_count -gt 0
430 then
431 say_color pass "# passed all $msg"
432 fi
d998bd4a
ÆAB
433 say "1..$test_count$skip_all"
434 fi
abc5d372
JS
435
436 test -d "$remove_trash" &&
437 cd "$(dirname "$remove_trash")" &&
438 rm -rf "$(basename "$remove_trash")"
439
342e9ef2
TR
440 test_at_end_hook_
441
e1970ce4
JH
442 exit 0 ;;
443
444 *)
1c0cc756
RJ
445 if test $test_external_has_tap -eq 0
446 then
d998bd4a
ÆAB
447 say_color error "# failed $test_failure among $msg"
448 say "1..$test_count"
449 fi
5099b99d 450
e1970ce4
JH
451 exit 1 ;;
452
453 esac
454}
455
e4597aae 456if test -n "$valgrind"
4e1be63c 457then
4e1be63c
JS
458 make_symlink () {
459 test -h "$2" &&
460 test "$1" = "$(readlink "$2")" || {
461 # be super paranoid
462 if mkdir "$2".lock
463 then
464 rm -f "$2" &&
465 ln -s "$1" "$2" &&
466 rm -r "$2".lock
467 else
468 while test -d "$2".lock
469 do
470 say "Waiting for lock on $2."
471 sleep 1
472 done
473 fi
474 }
475 }
476
477 make_valgrind_symlink () {
36bfb0e5
JK
478 # handle only executables, unless they are shell libraries that
479 # need to be in the exec-path. We will just use "#!" as a
480 # guess for a shell-script, since we have no idea what the user
481 # may have configured as the shell path.
482 test -x "$1" ||
483 test "#!" = "$(head -c 2 <"$1")" ||
484 return;
4e1be63c
JS
485
486 base=$(basename "$1")
6cec5c68 487 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
488 # do not override scripts
489 if test -x "$symlink_target" &&
490 test ! -d "$symlink_target" &&
491 test "#!" != "$(head -c 2 < "$symlink_target")"
492 then
493 symlink_target=../valgrind.sh
494 fi
efd92ffd
JS
495 case "$base" in
496 *.sh|*.perl)
497 symlink_target=../unprocessed-script
498 esac
4e1be63c
JS
499 # create the link, or replace it if it is out of date
500 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
501 }
502
503 # override all git executables in TEST_DIRECTORY/..
504 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
505 mkdir -p "$GIT_VALGRIND"/bin
6cec5c68 506 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
4e1be63c
JS
507 do
508 make_valgrind_symlink $file
509 done
ee0d7bf9
TR
510 # special-case the mergetools loadables
511 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
efd92ffd
JS
512 OLDIFS=$IFS
513 IFS=:
514 for path in $PATH
515 do
516 ls "$path"/git-* 2> /dev/null |
517 while read file
518 do
519 make_valgrind_symlink "$file"
520 done
521 done
522 IFS=$OLDIFS
4e1be63c
JS
523 PATH=$GIT_VALGRIND/bin:$PATH
524 GIT_EXEC_PATH=$GIT_VALGRIND/bin
525 export GIT_VALGRIND
1c0cc756
RJ
526elif test -n "$GIT_TEST_INSTALLED"
527then
e4597aae
MO
528 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
529 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 530 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
531 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
532else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 533 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
534 if ! test -x "$git_bin_dir/git"
535 then
536 if test -z "$with_dashes"
537 then
e4597aae
MO
538 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
539 fi
540 with_dashes=t
541 fi
542 PATH="$git_bin_dir:$PATH"
6cec5c68 543 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
544 if test -n "$with_dashes"
545 then
6cec5c68 546 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 547 fi
4e1be63c 548fi
6cec5c68 549GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 550unset GIT_CONFIG
8bfa6bd6 551GIT_CONFIG_NOSYSTEM=1
3c995beb 552GIT_ATTR_NOSYSTEM=1
8f323c00 553export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 554
5e87eae9
JH
555if test -z "$GIT_TEST_CMP"
556then
557 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
558 then
559 GIT_TEST_CMP="$DIFF -c"
560 else
561 GIT_TEST_CMP="$DIFF -u"
562 fi
563fi
564
6cec5c68 565GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 566export GITPERLLIB
6cec5c68 567test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
568 error "You haven't built things yet, have you?"
569}
e1970ce4 570
ac10a857 571if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63 572then
6cec5c68 573 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
2fe40b63 574 export GITPYTHONLIB
6cec5c68 575 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
2fe40b63
SR
576 error "You haven't built git_remote_helpers yet, have you?"
577 }
578fi
579
1c0cc756
RJ
580if ! test -x "$GIT_BUILD_DIR"/test-chmtime
581then
56cf9806
EW
582 echo >&2 'You need to build test-chmtime:'
583 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
584 exit 1
585fi
586
e1970ce4 587# Test repository
abc5d372 588test="trash directory.$(basename "$0" .sh)"
f423ef5f
JK
589test -n "$root" && test="$root/$test"
590case "$test" in
591/*) TRASH_DIRECTORY="$test" ;;
342e9ef2 592 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
f423ef5f 593esac
91c8b825 594test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
8d14ac94 595rm -fr "$test" || {
6e7b5aaf 596 GIT_EXIT_OK=t
8d14ac94
JH
597 echo >&5 "FATAL: Cannot prepare test area"
598 exit 1
599}
600
90cff968
AR
601HOME="$TRASH_DIRECTORY"
602export HOME
603
1c0cc756
RJ
604if test -z "$TEST_NO_CREATE_REPO"
605then
342e9ef2
TR
606 test_create_repo "$test"
607else
608 mkdir -p "$test"
609fi
1bd9c648
LW
610# Use -P to resolve symlinks in our working directory so that the cwd
611# in subprocesses like git equals our $PWD (for pathname comparisons).
612cd -P "$test" || exit 1
04ece593 613
d5d9de1b
JS
614this_test=${0##*/}
615this_test=${this_test%%-*}
04ece593
JH
616for skp in $GIT_SKIP_TESTS
617do
47e67d47
MG
618 case "$this_test" in
619 $skp)
55db1df0 620 say_color skip >&3 "skipping test $this_test altogether"
637ab29b 621 skip_all="skip all tests in $this_test"
04ece593
JH
622 test_done
623 esac
624done
f17e9fbb 625
8648732e
BC
626# Provide an implementation of the 'yes' utility
627yes () {
628 if test $# = 0
629 then
630 y=y
631 else
632 y="$*"
633 fi
634
635 while echo "$y"
636 do
637 :
638 done
639}
640
f17e9fbb
JS
641# Fix some commands on Windows
642case $(uname -s) in
643*MINGW*)
644 # Windows has its own (incompatible) sort and find
645 sort () {
646 /usr/bin/sort "$@"
647 }
648 find () {
649 /usr/bin/find "$@"
650 }
5397ea31
JS
651 sum () {
652 md5sum "$@"
653 }
4114156a
JS
654 # git sees Windows-style pwd
655 pwd () {
656 builtin pwd -W
657 }
ee9fb68c 658 # no POSIX permissions
6fd1106a 659 # backslashes in pathspec are converted to '/'
fb9a2bea 660 # exec does not inherit the PID
a94114ad 661 test_set_prereq MINGW
a31d0665
RJ
662 test_set_prereq SED_STRIPS_CR
663 ;;
664*CYGWIN*)
665 test_set_prereq POSIXPERM
a31d0665
RJ
666 test_set_prereq EXECKEEPSPID
667 test_set_prereq NOT_MINGW
668 test_set_prereq SED_STRIPS_CR
ee9fb68c
JS
669 ;;
670*)
671 test_set_prereq POSIXPERM
6fd1106a 672 test_set_prereq BSLASHPSPEC
fb9a2bea 673 test_set_prereq EXECKEEPSPID
3ba9ba8f 674 test_set_prereq NOT_MINGW
f17e9fbb
JS
675 ;;
676esac
704a3143 677
b082687c 678( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 679test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 680test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 681test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 682test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 683
bb946bba 684# Can we rely on git's output in the C locale?
30955229
JN
685if test -n "$GETTEXT_POISON"
686then
687 GIT_GETTEXT_POISON=YesPlease
688 export GIT_GETTEXT_POISON
5e9637c6 689 test_set_prereq GETTEXT_POISON
30955229
JN
690else
691 test_set_prereq C_LOCALE_OUTPUT
692fi
bb946bba 693
cabdee2c
JH
694# Use this instead of test_cmp to compare files that contain expected and
695# actual output from git commands that can be translated. When running
696# under GETTEXT_POISON this pretends that the command produced expected
697# results.
698test_i18ncmp () {
699 test -n "$GETTEXT_POISON" || test_cmp "$@"
700}
701
127df8c6
JH
702# Use this instead of "grep expected-string actual" to see if the
703# output from a git command that can be translated either contains an
704# expected string, or does not contain an unwanted one. When running
705# under GETTEXT_POISON this pretends that the command produced expected
706# results.
707test_i18ngrep () {
708 if test -n "$GETTEXT_POISON"
709 then
710 : # pretend success
711 elif test "x!" = "x$1"
712 then
713 shift
714 ! grep "$@"
715 else
716 grep "$@"
717 fi
718}
719
04083f27
JH
720test_lazy_prereq SYMLINKS '
721 # test whether the filesystem supports symbolic links
722 ln -s x y && test -h y
723'
c91cfd19 724
ac39aa61
MG
725test_lazy_prereq CASE_INSENSITIVE_FS '
726 echo good >CamelCase &&
727 echo bad >camelcase &&
728 test "$(cat CamelCase)" != good
729'
730
5b0b5dd4
MG
731test_lazy_prereq UTF8_NFD_TO_NFC '
732 # check whether FS converts nfd unicode to nfc
733 auml=$(printf "\303\244")
734 aumlcdiar=$(printf "\141\314\210")
735 >"$auml" &&
736 case "$(echo *)" in
737 "$aumlcdiar")
738 true ;;
739 *)
740 false ;;
741 esac
742'
743
09feffb6
JK
744test_lazy_prereq AUTOIDENT '
745 sane_unset GIT_AUTHOR_NAME &&
746 sane_unset GIT_AUTHOR_EMAIL &&
747 git var GIT_AUTHOR_IDENT
748'
749
c91cfd19
ÆAB
750# When the tests are run as root, permission tests will report that
751# things are writable when they shouldn't be.
752test -w / || test_set_prereq SANITY